﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace VerticalFontMaker
{
  public partial class MainForm : Form
  {
    public MainForm()
    {
      InitializeComponent();
    }

    private void OnBuildSourceFile(object sender, EventArgs e)
    {
      // get font dimensions width in pixels height in bytes
      int fontheight = Convert.ToInt32(numericFontHeight.Value);
      int fontwidth = Convert.ToInt32(numericFontWidth.Value);

      // select monochrome png file with symbols
      var dialog = new OpenFileDialog();
      dialog.InitialDirectory = Path.GetDirectoryName(Application.ExecutablePath);
      dialog.RestoreDirectory = true;
      //dialog.FileName = Path.GetFileName(SelectedFile);
      dialog.Filter = String.Format("Image files (*.{0})|*.{0}", "png");
      if (dialog.ShowDialog() != DialogResult.OK)
        return;

      // load png image and convert to bitmap
      Image img = Image.FromFile(dialog.FileName);
      Bitmap bmp = new Bitmap(img);

      //create text file and write font data
      string outputfile = Path.GetFileNameWithoutExtension(dialog.FileName) + ".txt";
      using (StreamWriter writer = new StreamWriter(outputfile))
      {
        for (int blx = 0; blx < bmp.Width; )
        {
          int blsz = Math.Min(fontwidth, bmp.Width - blx);
          
          writer.WriteLine("//Symbol {0}x{1},", blsz, fontheight * 8);

          for (int y = 0; y < fontheight; y++)
          {
            for (int x = 0; x < blsz; x++)
            {
              int acc = 0x00;
              for (int t = 0; t < 8; t++)
              {
                if (bmp.GetPixel(blx + x, y * 8 + t).ToArgb() != -1)
                {
                  acc |= 0x01 << t;
                }
              }
              writer.Write("0x{0:X2},", acc);
            }
            writer.WriteLine();
          }
          blx += blsz;
        }
      }

      // open text file with notepad
      System.Diagnostics.Process.Start(outputfile);
    }
  }
}
